// DglView.cpp : implementation file
//

#include "stdafx.h"
#include "mfc_gl.h"
#include "DglView.h"
#include "mfc_glView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CDglView	* DglView;
/////////////////////////////////////////////////////////////////////////////
// CDglView dialog


CDglView::CDglView(CWnd* pParent /*=NULL*/)
	: CDialog(CDglView::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDglView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
//  m_Sliderzpos=new CSliderCtrl();
//  m_Sliderxrot=new CSliderCtrl();
//  m_Slideryrot=new CSliderCtrl();
}


void CDglView::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDglView)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BOOL CDglView::OnInitDialog()
{
	CDialog::OnInitDialog();
	return TRUE;
}

BEGIN_MESSAGE_MAP(CDglView, CDialog)
	//{{AFX_MSG_MAP(CDglView)
	ON_BN_CLICKED(IDC_BUTTONRESET, OnButtonreset)
	ON_WM_CLOSE()
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDglView message handlers

void CDglView::OnButtonreset() 
{
	// TODO: Add your control notification handler code here
	Mfc_glView->xv=0;	Mfc_glView->zpos=+2;	//	Position de la vue
	Mfc_glView->zv=0;
	Mfc_glView->yrot=-90; Mfc_glView->xrot=30;
	Mfc_glView->CameraMoveStep=0.4f;
  Mfc_glView->MiseAjourDlgView();
  Mfc_glView->InvalidateRect(NULL);
}

void CDglView::OnOK() 
{
TCHAR SS[50];
CEdit * Ed;
CSliderCtrl* Sl;
	// TODO: Add extra validation here
  Ed=(CEdit*)GetDlgItem(IDC_EDITxv);
  Ed->GetLine(0, SS);
	Mfc_glView->xv = (float)_wtof(SS);

  Ed=(CEdit*)GetDlgItem(IDC_EDITzv);
  Ed->GetLine(0, SS);
	Mfc_glView->zv = (float)_wtof(SS);

  Ed=(CEdit*)GetDlgItem(IDC_EDITzpos);
  Ed->GetLine(0, SS);
	Mfc_glView->zpos = (float)_wtof(SS);

  Ed=(CEdit*)GetDlgItem(IDC_EDITxrot);
  Ed->GetLine(0, SS);
	Mfc_glView->xrot = (float)_wtof(SS);

  Ed=(CEdit*)GetDlgItem(IDC_EDITyrot);
  Ed->GetLine(0, SS);
	Mfc_glView->yrot = (float)_wtof(SS);

	Sl=(CSliderCtrl*)GetDlgItem(IDC_EDITzpos);
	Sl->SetPos((int)Mfc_glView->zpos);
	Sl=(CSliderCtrl*)GetDlgItem(IDC_EDITxrot);
	Sl->SetPos((int)Mfc_glView->xrot);
	Sl=(CSliderCtrl*)GetDlgItem(IDC_EDITyrot);
	Sl->SetPos((int)Mfc_glView->yrot);
/*
  m_Sliderzpos->SetPos((int)Mfc_glView->zpos);
  m_Sliderxrot->SetPos((int)Mfc_glView->xrot);
  m_Slideryrot->SetPos((int)Mfc_glView->yrot);
*/
  Mfc_glView->InvalidateRect(NULL);
//	CDialog::OnOK();
}

void CDglView::OnCancel() 
{
	// TODO: Add extra cleanup here
//	CDialog::OnCancel();
}

void CDglView::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	CDialog::OnCancel();
}

void CDglView::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
TCHAR buffer[50];
CEdit * Ed;
CSliderCtrl* Sl;
  Sl=(CSliderCtrl*)pScrollBar;
	switch (Sl->GetDlgCtrlID())
	{
	case IDC_SLIDERzpos : Mfc_glView->zpos=(float)Sl->GetPos();
											  Ed=(CEdit*)GetDlgItem(IDC_EDITzpos);
											  Ed->SetSel(0,-1);
												wsprintf(buffer, L"%.6g", Mfc_glView->zpos);
												Ed->ReplaceSel(buffer);
											  break;
	case IDC_SLIDERxrot : Mfc_glView->xrot=(float)Sl->GetPos();
											  Ed=(CEdit*)GetDlgItem(IDC_EDITxrot);
											  Ed->SetSel(0,-1);
												wsprintf(buffer, L"%.6g", Mfc_glView->xrot);
												Ed->ReplaceSel(buffer);
											  break;
	case IDC_SLIDERyrot : Mfc_glView->yrot=(float)Sl->GetPos();
											  Ed=(CEdit*)GetDlgItem(IDC_EDITyrot);
											  Ed->SetSel(0,-1);
												wsprintf(buffer, L"%.6g", Mfc_glView->yrot);
												Ed->ReplaceSel(buffer);
											  break;
	}
  Mfc_glView->InvalidateRect(NULL);
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CDglView::initSliders()
{
	// get the pointer
	m_Sliderzpos=(CSliderCtrl*)GetDlgItem(IDC_SLIDERzpos);
  m_Sliderzpos->SetRange(0,30,true);
  m_Sliderzpos->SetPos((int)Mfc_glView->zpos);

	m_Sliderxrot=(CSliderCtrl*)GetDlgItem(IDC_SLIDERxrot);
  m_Sliderxrot->SetRange(-180,180,true);
  m_Sliderxrot->SetPos((int)Mfc_glView->xrot);

	m_Slideryrot=(CSliderCtrl*)GetDlgItem(IDC_SLIDERyrot);
  m_Slideryrot->SetRange(-180,180,true);
  m_Slideryrot->SetPos((int)Mfc_glView->yrot);
}