// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "mfc_gl.h"

#include "MainFrm.h"
#include "mfc_glView.h"

//#define ID_Xpos 1 
//#define ID_Ypos 2 

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_UPDATE_COMMAND_UI ( ID_INDICATOR_Frame, OnUpdatePane )
	ON_UPDATE_COMMAND_UI ( ID_INDICATOR_Text, OnUpdatePane )
	ON_UPDATE_COMMAND_UI ( ID_INDICATOR_RobSel, OnUpdatePane )
	ON_CBN_SELCHANGE(ID_CBListe,CMainFrame::CBListe_ChangeSelection)
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT))
			)
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}
	m_wndStatusBar.SetPaneInfo(0, ID_INDICATOR_Frame, SBPS_NORMAL ,250);
	m_wndStatusBar.SetPaneInfo(1, ID_INDICATOR_Text, SBPS_NORMAL,200);
	m_wndStatusBar.SetPaneInfo(2, ID_INDICATOR_RobSel, SBPS_NORMAL ,150);
	
	m_wndStatusBar.SetPaneText(0, L"");
	m_wndStatusBar.SetPaneText(1, L"");
	m_wndStatusBar.SetPaneText(2, L"");
	
	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
	// Ajout d'un CComboListe
	int nWidth=200;
	int nHeight=300;
	m_wndToolBar.SetButtonInfo(10,ID_CBListe,TBBS_SEPARATOR,nWidth);
	CRect rect;
	m_wndToolBar.GetItemRect(10,&rect);
	rect.bottom=rect.top+nHeight;

	m_ComboListe.Create(WS_CHILD |WS_VISIBLE|WS_VSCROLL|CBS_DROPDOWNLIST,
					rect,&m_wndToolBar,ID_CBListe);
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}
void CMainFrame::CBListe_ChangeSelection()
{
	CMfc_glView * pMfc_glView = static_cast<CMfc_glView *>(GetActiveView());
	pMfc_glView->NewRobSel = m_ComboListe.GetCurSel();
	if (pMfc_glView->NewRobSel<0 || pMfc_glView->NewRobSel>pMfc_glView->NRobots)
						{
						AfxMessageBox( L"Valeur entre en dehors des limites",MB_ICONEXCLAMATION);
						return;
						}
	pMfc_glView->ListeRobots[pMfc_glView->RobSel]->Selected=false;		//! n'est plus selectionn, la selection change
	pMfc_glView->RobSel=pMfc_glView->NewRobSel;
	pMfc_glView->ListeRobots[pMfc_glView->RobSel]->Selected=true;
	InvalidateRect(NULL);										// mets  jour l'affichage
	pMfc_glView->UpdateStatusBarRobSel();
	pMfc_glView->SetFocus();
}


/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers
