//----------------------------------------------------------------
// fichier .h des classes des robots
//
//----------------------------------------------------------------
#define TypeRobotK		1
#define TypeRobot2		2	
#define TypeRobot4		4

//----------------------------------------------------------------
class TRoue
{
public :
// membres :
	double	M, R, r;		// Masse, Rayon, petit rayon
	double	W, Theta;						// position et vitesse angulaires instantanes
	double	Delta;						// angle de braquage
	virtual void Dessine(double posx, double posy, int type);
	virtual void Reset();		// reset coord.
	TRoue();
};
//----------------------------------------------------------------
class TRobot2
{
public :
// membres :
//	TTexte	Algo;	// Programme_de_commande_du_robot
	TRoue * RAvD, * RAvG;  //	* RArG, * RArD;	 les roues
	double	M, Lx, Ly,  e, Gabarit;	// Masse, Longueur entre essieux, Longeur essieu-essieu
																	// epaisseur, Gabarit (rayon pour collision !)
	double	Lxc, Lyc, Lzc;	// dimension chassi
	double	Fx, Fy;								// Force (rammene au Centre de Gravit) rsultant de l'action des roues
	double	PosX, PosY, VitX, VitY, Vit, kech;			// posistion et vitesse instantnes, echelle de visualisation
	double	PosX0, PosY0;								// posistion  l'origine
	double	DeltaR, W;							// angle et vitesse de rotation (repere x'y' % xy )
	int Type;								//type de robot 2, 4 ou K==1;
	int Numero;								// indice du robot
	bool Selected;						// pour savoir si le robot est selectionn ou pas
// methodes
	virtual void Dessine();		// se dessine
	virtual void IntegreEquations(double dt);		// integre ses equation mcanique (RFD) en RungeKutta4 par exemple
															// pour simuler le deplacement
	virtual void Pilotage(double t);		// suit une trajectoire
	virtual void Reset();		// reset coord.
	TRobot2(double APosX0, double APosY0, int num);
	~TRobot2();
};
//----------------------------------------------------------------

